This sample demonstrates a Order Management view created with the [MultiRow]MultiRow control.
loading...import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjMultiRow from '@mescius/wijmo.grid.multirow';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjPdf from '@mescius/wijmo.pdf';
import { getOrders } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let items = new wjCore.CollectionView(getOrders(20));
items.pageSize = 5;
let orderManagement = new wjMultiRow.MultiRow('#orderManagement', {
itemsSource: items,
layoutDefinition: generateLayoutDef()
});
let cv = orderManagement.collectionView;
currentPageChanged();
cv.pageChanged.addHandler(() => {
currentPageChanged();
});
cv.collectionChanged.addHandler((sender, e) => {
let unitPrice, quantity;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
unitPrice = +e.item.unitPrice;
quantity = +e.item.quantity;
if (!isNaN(unitPrice) && !isNaN(quantity)) {
e.item.amount = unitPrice * quantity;
}
}
});
document.querySelector('#first').addEventListener('click', () => {
cv.moveToFirstPage();
});
document.querySelector('#previous').addEventListener('click', () => {
cv.moveToPreviousPage();
});
document.querySelector('#next').addEventListener('click', () => {
cv.moveToNextPage();
});
document.querySelector('#last').addEventListener('click', () => {
cv.moveToLastPage();
});
// Generate the layout definition for the MultiRow control.
function generateLayoutDef() {
var warehouseDataMap = buildDataMap('Tokyo Warehouse, Kyoto Warehouse, Osaka Warehouse, Kyushu Warehouse'.split(','));
return [
{
colspan: 3,
cells: [
{ binding: 'orderId', header: 'Order ID', width: 80 },
{ binding: 'productId', header: 'Product ID', width: 80 },
{ binding: 'productName', header: 'Product Name', width: 180 },
{ binding: 'specialNote', header: 'Special Note', align: 'center', colspan: 3 }
]
},
{
colspan: 3,
cells: [
{ binding: 'quantity', header: 'Quantity', width: 80 },
{ binding: 'unitPrice', header: 'Unit Price', width: 80, format: 'c2' },
{ binding: 'amount', header: 'Amount', isReadOnly: true, width: 80, format: 'c2' },
{ binding: 'shippingWarehouse', header: 'Shipping Warehouse', dataMap: warehouseDataMap, align: 'center', colspan: 2 },
{ binding: 'onHold', header: 'On Hold' },
]
},
{
cells: [
{ binding: 'orderDate', header: 'Order Date', format: 'yyyy/MM/dd' },
{ binding: 'deliveryDate', header: 'Delivery Date', format: 'yyyy/MM/dd' }
]
}
];
}
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
function currentPageChanged() {
let cv = orderManagement.collectionView, curr = wjCore.format('{current:n0} / {count:n0}', {
current: cv.pageIndex + 1,
count: cv.pageCount
});
document.querySelector('#current').innerHTML = curr;
if (cv.pageIndex === 0) {
document.querySelector('#first').setAttribute('disabled', 'true');
document.querySelector('#previous').setAttribute('disabled', 'true');
}
else {
document.querySelector('#first').removeAttribute('disabled');
document.querySelector('#previous').removeAttribute('disabled');
}
if (cv.pageIndex === cv.pageCount - 1) {
document.querySelector('#last').setAttribute('disabled', 'true');
document.querySelector('#next').setAttribute('disabled', 'true');
}
else {
document.querySelector('#last').removeAttribute('disabled');
document.querySelector('#next').removeAttribute('disabled');
}
}
document.querySelector('#exportXlsx').addEventListener('click', () => {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(orderManagement, null, 'OrderManagement.xlsx');
});
document.querySelector('#exportPdf').addEventListener('click', () => {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, 'OrderManagement.pdf');
}
}), settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
};
wjGridPdf.FlexGridPdfConverter.draw(orderManagement, doc, null, null, settings);
doc.end();
});
}
Submit and view feedback for

<template>
<div class="container-fluid">
<wj-multi-row :itemsSource="items" :layoutDefinition="layoutDefinition"
:initialized="initialized"></wj-multi-row>
<div class="pull-right btn-group">
<button class="btn btn-default" @click="onGotoPageClick('first')" id="first">
<span class="glyphicon glyphicon-fast-backward"></span>
</button>
<button class="btn btn-default" @click="onGotoPageClick('previous')" id="previous">
<span class="glyphicon glyphicon-backward"></span>
</button>
<button id="current" type="button" class="btn" disabled style="width:100px"
v-html="currentDescription"></button>
<button class="btn btn-default" @click="onGotoPageClick('next')" id="next">
<span class="glyphicon glyphicon-forward"></span>
</button>
<button class="btn btn-default" @click="onGotoPageClick('last')" id="last">
<span class="glyphicon glyphicon-fast-forward"></span>
</button>
</div>
<div class="btn-group">
<button class="btn btn-default" @click="onExportXlsxClick()">Export to Excel</button>
<button class="btn btn-default" @click="onExportPdfClick()">Export to PDF</button>
</div>
</div>
</template>
<script setup>
import * as wjCore from "@mescius/wijmo";
import * as wjPdf from "@mescius/wijmo.pdf";
import * as wjMultirow from "@mescius/wijmo.grid.multirow";
import * as wjGridXlsx from "@mescius/wijmo.grid.xlsx";
import * as wjGridPdf from "@mescius/wijmo.grid.pdf";
import { getOrders, generateLayoutDef, Order, Line } from "./data";
import { ref } from "vue";
const items = ref(null);
const collectionView = ref(null);
const layoutDefinition = ref(null);
const currentDescription = ref(null);
const orderManagement = ref(null);
items.value = new wjCore.CollectionView(getOrders(20));
items.value.pageSize = 5;
layoutDefinition.value = generateLayoutDef();
function onGotoPageClick(command) {
let cv = collectionView.value;
if (command === "first") {
cv.moveToFirstPage();
} else if (command === "previous") {
cv.moveToPreviousPage();
} else if (command === "next") {
cv.moveToNextPage();
} else if (command === "last") {
cv.moveToLastPage();
}
}
function onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(orderManagement.value, null, "OrderManagement.xlsx");
}
function onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
footer: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, "OrderManagement.pdf");
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6",
},
altCellStyle: {
backgroundColor: "#C0FFC0",
},
headerCellStyle: {
backgroundColor: "#eaeaea",
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(orderManagement.value, doc, null, null, settings);
doc.end();
}
function currentPageChanged() {
let cv = collectionView.value;
let curr = wjCore.format("{current:n0} / {count:n0}", {
current: cv.pageIndex + 1,
count: cv.pageCount,
});
currentDescription.value = curr;
if (cv.pageIndex === 0) {
document.querySelector("#first").setAttribute("disabled", "true");
document.querySelector("#previous").setAttribute("disabled", "true");
} else {
document.querySelector("#first").removeAttribute("disabled");
document.querySelector("#previous").removeAttribute("disabled");
}
if (cv.pageIndex === cv.pageCount - 1) {
document.querySelector("#last").setAttribute("disabled", "true");
document.querySelector("#next").setAttribute("disabled", "true");
} else {
document.querySelector("#last").removeAttribute("disabled");
document.querySelector("#next").removeAttribute("disabled");
}
}
function initialized(orderManagementref) {
orderManagement.value = orderManagementref;
collectionView.value = orderManagement.value.collectionView;
currentPageChanged();
collectionView.value.pageChanged.addHandler(() => {
currentPageChanged();
});
collectionView.value.collectionChanged.addHandler((sender, e) => {
let unitPrice, quantity;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
unitPrice = +e.item.unitPrice;
quantity = +e.item.quantity;
if (!isNaN(unitPrice) && !isNaN(quantity)) {
e.item.amount = unitPrice * quantity;
}
}
});
}
</script>
<style>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
#orderDetail .wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background-color: #c0ffc0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Order Management</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid'
let products = [
{ id: 'D0001', name: 'Chai', unitPrice: 12, profitUnitPrice: 3.11 },
{ id: 'D0002', name: 'Chang', unitPrice: 8.5, profitUnitPrice: 2.03 },
{ id: 'D0003', name: 'Aniseed Syrup', unitPrice: 6.85, profitUnitPrice: 2.35 },
{ id: 'D0004', name: 'Chef Anton\'s Gumbo Mix', unitPrice: 17.25, profitUnitPrice: 3.3 },
{ id: 'D0005', name: 'Ikura', unitPrice: 20, profitUnitPrice: 2.95 },
{ id: 'D0006', name: 'Mishi Kobe Niku', unitPrice: 14, profitUnitPrice: 3 },
];
function randBetween(min, max) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
export function getOrders(count){
let orders = [];
for (let i = 0; i < count; i++) {
let product = products[Math.floor(Math.random() * 6)],
quantity = randBetween(100, 999),
orderDate = new Date(2016, i % 12, i % 28);
orders[i] = {
orderId: 'C' + wjCore.Globalize.format(i + 1, 'd4'),
productId: product.id,
productName: product.name,
specialNote: '',
quantity: quantity,
unitPrice: product.unitPrice,
shippingWarehouse: Math.floor(Math.random() * 4),
amount: quantity * product.unitPrice,
onHold: Math.random() > 0.5,
orderDate: orderDate,
deliveryDate: new Date(2016, orderDate.getMonth() + 1, orderDate.getDate() + 15)
}
}
return orders;
}
export function generateLayoutDef(){
var warehouseDataMap = buildDataMap('Tokyo Warehouse, Kyoto Warehouse, Osaka Warehouse, Kyushu Warehouse'.split(','));
return [
{
colspan: 3,
cells: [
{ binding: 'orderId', header: 'Order ID', width: 80 },
{ binding: 'productId', header: 'Product ID', width: 80 },
{ binding: 'productName', header: 'Product Name', width: 180 },
{ binding: 'specialNote', header: 'Special Note', align: 'center', colspan: 3 }
]
},
{
colspan: 3,
cells: [
{ binding: 'quantity', header: 'Quantity', width: 80 },
{ binding: 'unitPrice', header: 'Unit Price', width: 80, format: 'c2' },
{ binding: 'amount', header: 'Amount', isReadOnly: true, width: 80, format: 'c2' },
{ binding: 'shippingWarehouse', header: 'Shipping Warehouse', dataMap: warehouseDataMap, align: 'center', colspan: 2 },
{ binding: 'onHold', header: 'On Hold' },
]
},
{
cells: [
{ binding: 'orderDate', header: 'Order Date', format: 'yyyy/MM/dd' },
{ binding: 'deliveryDate', header: 'Delivery Date', format: 'yyyy/MM/dd' }
]
}
];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjCore from '@mescius/wijmo';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjMultirow from '@mescius/wijmo.grid.multirow';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridMultirowModule } from '@mescius/wijmo.angular2.grid.multirow';
import { DataService, Order, Line } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridMultirowModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements AfterViewInit {
@ViewChild('orderManagement', { static: true }) orderManagement: wjMultirow.MultiRow;
items: wjCore.CollectionView;
cv: wjCore.CollectionView;
layoutDefinition: Line[];
currentDescription: string;
// DataSvc will be passed by derived classes
constructor(@Inject(DataService) private dataService: DataService) {
this.items = new wjCore.CollectionView(dataService.getOrders(20));
this.items.pageSize = 5;
this.layoutDefinition = dataService.generateLayoutDef();
}
//
ngAfterViewInit() {
this.cv = <wjCore.CollectionView>this.orderManagement.collectionView;
this._currentPageChanged();
this.cv.pageChanged.addHandler(() => {
this._currentPageChanged();
});
this.cv.collectionChanged.addHandler((sender: any, e: wjCore.NotifyCollectionChangedEventArgs) => {
let unitPrice: number, quantity: number;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
unitPrice = +e.item.unitPrice;
quantity = +e.item.quantity;
if (!isNaN(unitPrice) && !isNaN(quantity)) {
e.item.amount = unitPrice * quantity;
}
}
});
}
//
onGotoPageClick(command: string) {
let cv = this.cv;
if (command === 'first') {
cv.moveToFirstPage();
} else if (command === 'previous') {
cv.moveToPreviousPage();
} else if (command === 'next') {
cv.moveToNextPage();
} else if (command === 'last') {
cv.moveToLastPage();
}
}
//
onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(this.orderManagement, null, 'OrderManagement.xlsx');
}
//
onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
ended: function (sender: wjPdf.PdfDocument, args: wjPdf.PdfDocumentEndedEventArgs) {
wjPdf.saveBlob(args.blob, 'OrderManagement.pdf');
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6',
},
altCellStyle: {
backgroundColor: '#C0FFC0',
},
headerCellStyle: {
backgroundColor: '#eaeaea',
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(this.orderManagement, doc, null, null, settings);
doc.end();
}
//
private _currentPageChanged() {
let cv = this.cv;
let curr = wjCore.format('{current:n0} / {count:n0}', {
current: cv.pageIndex + 1,
count: cv.pageCount,
});
this.currentDescription = curr;
if (cv.pageIndex === 0) {
document.querySelector('#first').setAttribute('disabled', 'true');
document.querySelector('#previous').setAttribute('disabled', 'true');
} else {
document.querySelector('#first').removeAttribute('disabled');
document.querySelector('#previous').removeAttribute('disabled');
}
if (cv.pageIndex === cv.pageCount - 1) {
document.querySelector('#last').setAttribute('disabled', 'true');
document.querySelector('#next').setAttribute('disabled', 'true');
} else {
document.querySelector('#last').removeAttribute('disabled');
document.querySelector('#next').removeAttribute('disabled');
}
}
}
//\\
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Order Detail</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<wj-multi-row #orderManagement [itemsSource]="items" [layoutDefinition]="layoutDefinition"></wj-multi-row>
<div class="pull-right btn-group">
<button class="btn btn-default" (click)="onGotoPageClick('first')" id="first">
<span class="glyphicon glyphicon-fast-backward"></span>
</button>
<button class="btn btn-default" (click)="onGotoPageClick('previous')" id="previous">
<span class="glyphicon glyphicon-backward"></span>
</button>
<button id="current" type="button" class="btn" disabled style="width:100px" [innerHTML]="currentDescription">
</button>
<button class="btn btn-default" (click)="onGotoPageClick('next')" id="next">
<span class="glyphicon glyphicon-forward"></span>
</button>
<button class="btn btn-default" (click)="onGotoPageClick('last')" id="last">
<span class="glyphicon glyphicon-fast-forward"></span>
</button>
</div>
<div class="btn-group">
<button class="btn btn-default" (click)="onExportXlsxClick()">
Export to Excel
</button>
<button class="btn btn-default" (click)="onExportPdfClick()">
Export to PDF
</button>
</div>
</div>
import { Injectable } from '@angular/core';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
export interface Order {
orderId: string;
productId: string;
productName: string;
specialNote: string;
quantity: number;
unitPrice: number;
shippingWarehouse: number;
amount: number;
onHold: boolean;
orderDate: Date;
deliveryDate: Date;
}
export interface Cell {
binding: string;
header: string;
cssClass?: string;
format?: string;
isReadOnly?: boolean;
wordWrap?: boolean;
width?: number;
colspan?: number;
align?: string;
dataMap?: wjGrid.DataMap;
}
export interface Line {
cells: Cell[];
header?: string;
colspan?: number;
}
let products = [
{ id: 'D0001', name: 'Chai', unitPrice: 12, profitUnitPrice: 3.11 },
{ id: 'D0002', name: 'Chang', unitPrice: 8.5, profitUnitPrice: 2.03 },
{ id: 'D0003', name: 'Aniseed Syrup', unitPrice: 6.85, profitUnitPrice: 2.35 },
{ id: 'D0004', name: 'Chef Anton\'s Gumbo Mix', unitPrice: 17.25, profitUnitPrice: 3.3 },
{ id: 'D0005', name: 'Ikura', unitPrice: 20, profitUnitPrice: 2.95 },
{ id: 'D0006', name: 'Mishi Kobe Niku', unitPrice: 14, profitUnitPrice: 3 },
];
function randBetween(min: number, max: number): number {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function buildDataMap(items: string[]): wjGrid.DataMap {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
@Injectable()
export class DataService {
getOrders(count: number): Order[] {
let orders = [];
for (let i = 0; i < count; i++) {
let product = products[Math.floor(Math.random() * 6)],
quantity = randBetween(100, 999),
orderDate = new Date(2016, i % 12, i % 28);
orders[i] = {
orderId: 'C' + wjCore.Globalize.format(i + 1, 'd4'),
productId: product.id,
productName: product.name,
specialNote: '',
quantity: quantity,
unitPrice: product.unitPrice,
shippingWarehouse: Math.floor(Math.random() * 4),
amount: quantity * product.unitPrice,
onHold: Math.random() > 0.5,
orderDate: orderDate,
deliveryDate: new Date(2016, orderDate.getMonth() + 1, orderDate.getDate() + 15)
}
}
return orders;
}
generateLayoutDef(): Line[] {
var warehouseDataMap = buildDataMap('Tokyo Warehouse, Kyoto Warehouse, Osaka Warehouse, Kyushu Warehouse'.split(','));
return [
{
colspan: 3,
cells: [
{ binding: 'orderId', header: 'Order ID', width: 80 },
{ binding: 'productId', header: 'Product ID', width: 80 },
{ binding: 'productName', header: 'Product Name', width: 180 },
{ binding: 'specialNote', header: 'Special Note', align: 'center', colspan: 3 }
]
},
{
colspan: 3,
cells: [
{ binding: 'quantity', header: 'Quantity', width: 80 },
{ binding: 'unitPrice', header: 'Unit Price', width: 80, format: 'c2' },
{ binding: 'amount', header: 'Amount', isReadOnly: true, width: 80, format: 'c2' },
{ binding: 'shippingWarehouse', header: 'Shipping Warehouse', dataMap: warehouseDataMap, align: 'center', colspan: 2 },
{ binding: 'onHold', header: 'On Hold' },
]
},
{
cells: [
{ binding: 'orderDate', header: 'Order Date', format: 'yyyy/MM/dd' },
{ binding: 'deliveryDate', header: 'Delivery Date', format: 'yyyy/MM/dd' }
]
}
];
}
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
#orderDetail .wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected){
background-color: #C0FFC0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjMultiRow from '@mescius/wijmo.react.grid.multirow';
import * as wjCore from '@mescius/wijmo';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import './app.css';
import { generateLayoutDef, getOrders } from './data';
const items = new wjCore.CollectionView(getOrders(20));
items.pageSize = 5;
function App() {
const [layoutDefinition, setLayoutDefinition] = useState(generateLayoutDef());
const [orderManagement, setOrderManagement] = useState(null);
const [currentDescription, setCurrentDescription] = useState(null);
const [cv, setCv] = useState(null);
const initialized = useEvent((orderManagement) => {
const cv = orderManagement.collectionView;
setOrderManagement(orderManagement);
setCv(cv);
currentPageChanged(cv);
cv.pageChanged.addHandler(() => {
currentPageChanged(cv);
});
cv.collectionChanged.addHandler((sender, e) => {
let unitPrice, quantity;
if (e.action === wjCore.NotifyCollectionChangedAction.Change &&
!!e.item) {
unitPrice = +e.item.unitPrice;
quantity = +e.item.quantity;
if (!isNaN(unitPrice) && !isNaN(quantity)) {
e.item.amount = unitPrice * quantity;
}
}
});
});
const currentPageChanged = (cv) => {
var _a, _b, _c, _d, _e, _f, _g, _h;
let curr = wjCore.format("{current:n0} / {count:n0}", {
current: cv.pageIndex + 1,
count: cv.pageCount
});
setCurrentDescription(curr);
if (cv.pageIndex === 0) {
(_a = document.querySelector("#first")) === null || _a === void 0 ? void 0 : _a.setAttribute("disabled", "true");
(_b = document.querySelector("#previous")) === null || _b === void 0 ? void 0 : _b.setAttribute("disabled", "true");
}
else {
(_c = document.querySelector("#first")) === null || _c === void 0 ? void 0 : _c.removeAttribute("disabled");
(_d = document.querySelector("#previous")) === null || _d === void 0 ? void 0 : _d.removeAttribute("disabled");
}
if (cv.pageIndex === cv.pageCount - 1) {
(_e = document.querySelector("#last")) === null || _e === void 0 ? void 0 : _e.setAttribute("disabled", "true");
(_f = document.querySelector("#next")) === null || _f === void 0 ? void 0 : _f.setAttribute("disabled", "true");
}
else {
(_g = document.querySelector("#last")) === null || _g === void 0 ? void 0 : _g.removeAttribute("disabled");
(_h = document.querySelector("#next")) === null || _h === void 0 ? void 0 : _h.removeAttribute("disabled");
}
};
const onGotoPageClick = (command) => {
if (command === "first") {
cv.moveToFirstPage();
}
else if (command === "previous") {
cv.moveToPreviousPage();
}
else if (command === "next") {
cv.moveToNextPage();
}
else if (command === "last") {
cv.moveToLastPage();
}
};
const onExportXlsxClick = () => {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(orderManagement, undefined, "OrderManagement.xlsx");
};
const onExportPdfClick = () => {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: "\t&[Page]\\&[Pages]"
}
},
footer: {
declarative: {
text: "\t&[Page]\\&[Pages]"
}
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, "OrderManagement.pdf");
}
}), settings = {
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6"
},
altCellStyle: {
backgroundColor: "#C0FFC0"
},
headerCellStyle: {
backgroundColor: "#eaeaea"
}
}
};
wjGridPdf.FlexGridPdfConverter.draw(orderManagement, doc, undefined, undefined, settings);
doc.end();
};
return (<div className="container-fluid">
<wjMultiRow.MultiRow itemsSource={items} layoutDefinition={layoutDefinition} initialized={initialized}/>
<div className="pull-right btn-group">
<button className="btn btn-default" onClick={(e) => onGotoPageClick('first')} id="first">
<span className="glyphicon glyphicon-fast-backward"/>
</button>
<button className="btn btn-default" onClick={(e) => onGotoPageClick('previous')} id="previous">
<span className="glyphicon glyphicon-backward"/>
</button>
<button id="current" type="button" className="btn" disabled style={{ width: "100px" }} dangerouslySetInnerHTML={{ __html: currentDescription }}/>
<button className="btn btn-default" onClick={(e) => onGotoPageClick('next')} id="next">
<span className="glyphicon glyphicon-forward"></span>
</button>
<button className="btn btn-default" onClick={(e) => onGotoPageClick('last')} id="last">
<span className="glyphicon glyphicon-fast-forward"></span>
</button>
</div>
<div className="btn-group">
<button className="btn btn-default" onClick={onExportXlsxClick}>
Export to Excel
</button>
<button className="btn btn-default" onClick={onExportPdfClick}>
Export to PDF
</button>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo MultiRow Order Management</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
#orderDetail .wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background-color: #C0FFC0;
}
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
let products = [
{ id: 'D0001', name: 'Chai', unitPrice: 12, profitUnitPrice: 3.11 },
{ id: 'D0002', name: 'Chang', unitPrice: 8.5, profitUnitPrice: 2.03 },
{ id: 'D0003', name: 'Aniseed Syrup', unitPrice: 6.85, profitUnitPrice: 2.35 },
{ id: 'D0004', name: 'Chef Anton\'s Gumbo Mix', unitPrice: 17.25, profitUnitPrice: 3.3 },
{ id: 'D0005', name: 'Ikura', unitPrice: 20, profitUnitPrice: 2.95 },
{ id: 'D0006', name: 'Mishi Kobe Niku', unitPrice: 14, profitUnitPrice: 3 },
];
function randBetween(min, max) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
export function getOrders(count) {
let orders = [];
for (let i = 0; i < count; i++) {
let product = products[Math.floor(Math.random() * 6)], quantity = randBetween(100, 999), orderDate = new Date(2016, i % 12, i % 28);
orders[i] = {
orderId: 'C' + wjCore.Globalize.format(i + 1, 'd4'),
productId: product.id,
productName: product.name,
specialNote: '',
quantity: quantity,
unitPrice: product.unitPrice,
shippingWarehouse: Math.floor(Math.random() * 4),
amount: quantity * product.unitPrice,
onHold: Math.random() > 0.5,
orderDate: orderDate,
deliveryDate: new Date(2016, orderDate.getMonth() + 1, orderDate.getDate() + 15)
};
}
return orders;
}
export function generateLayoutDef() {
var warehouseDataMap = buildDataMap('Tokyo Warehouse, Kyoto Warehouse, Osaka Warehouse, Kyushu Warehouse'.split(','));
return [
{
colspan: 3,
cells: [
{ binding: 'orderId', header: 'Order ID', width: 80 },
{ binding: 'productId', header: 'Product ID', width: 80 },
{ binding: 'productName', header: 'Product Name', width: 180 },
{ binding: 'specialNote', header: 'Special Note', align: 'center', colspan: 3 }
]
},
{
colspan: 3,
cells: [
{ binding: 'quantity', header: 'Quantity', width: 80 },
{ binding: 'unitPrice', header: 'Unit Price', width: 80, format: 'c2' },
{ binding: 'amount', header: 'Amount', isReadOnly: true, width: 80, format: 'c2' },
{ binding: 'shippingWarehouse', header: 'Shipping Warehouse', dataMap: warehouseDataMap, align: 'center', colspan: 2 },
{ binding: 'onHold', header: 'On Hold' },
]
},
{
cells: [
{ binding: 'orderDate', header: 'Order Date', format: 'yyyy/MM/dd' },
{ binding: 'deliveryDate', header: 'Delivery Date', format: 'yyyy/MM/dd' }
]
}
];
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);